<script lang="ts">
import { defineComponent, computed } from 'vue';

const clickEmitName = 'change';

export default defineComponent({
  name: 'JTabHeaderItem',
  props: {
    index: {
      type: Number,
      required: true,
    },
    activeIndex: {
      type: Object,
      required: true,
    },
  },
  emits: [clickEmitName],
  setup(props) {
    const isActive = computed(() => props.index === props.activeIndex?.value);

    return {
      clickEmitName,
      isActive,
    };
  },
});
</script>

<template>
  <div
    v-ripple
    class="j-tab-header-item"
    :class="{ active: isActive }"
    tabindex="0"
    role="tab"
    :aria-selected="isActive"
    @click="$emit(clickEmitName, index)"
    @keydown.enter="$emit(clickEmitName, index)"
    @keydown.space="$emit(clickEmitName, index)"
  >
    <span class="j-tab-header-item-label">
      <slot />
    </span>
  </div>
</template>

<style scoped lang="scss">
@use '../../../styles/tools/mixins' as mixins;

.j-tab-header-item {
  display: flex;
  align-items: center;
  justify-content: center;
  position: relative;
  padding: 0 12px;
  min-width: 114px;
  max-width: 360px;
  cursor: pointer;
  box-sizing: border-box;

  &::before {
    content: "";
    position: absolute;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    opacity: 0;
    cursor: pointer;
    transition: .3s cubic-bezier(.25,.8,.5,1);
    background-color: currentColor;
  }

  &:hover::before {
    opacity: 0.04;
  }

  &:focus::before {
    opacity: 0.12;
  }

  &.active {
    color: #000000de;
  }
}

.j-tab-header-item-label {
  @include mixins.line-clamp();
}
</style>
